#define DS3231_ADDR   0x68

#define VFDLOAD_DDR   DDRC
#define VFDLOAD_PORT  PORTC
#define VFDLOAD       PORTC0

#define BOOST_DDR     DDRD
#define BOOST_PORT    PORTD
#define BOOST         PORTD6

//#define PPS_DDR       DDRB
//#define PPS_PIN       PINB
//#define PPS           PORTB0

#define ENC_A_DDR     DDRD
#define ENC_A_PIN     PIND
#define ENC_A_PORT    PORTD
#define ENC_A         PORTD5
#define ENC_A_ARDUINO 5

#define ENC_B_DDR     DDRD
#define ENC_B_PIN     PIND
#define ENC_B_PORT    PORTD
#define ENC_B         PORTD4
#define ENC_B_ARDUINO 4

#define ENC_SW_DDR    DDRB
#define ENC_SW_PIN    PINB
#define ENC_SW_PORT   PORTB
#define ENC_SW        PORTB0
#define ENC_B_ARDUINO 8

#define ALARM_DDR DDRD
#define ALARM_PORT PORTD
#define ALARM_PIN PIND
#define ALARM PORTD2
#define ALARM_ARDUINO 2

#define VFD_SEG_A     0b00000001
#define VFD_SEG_B     0b00000010
#define VFD_SEG_C     0b00000100
#define VFD_SEG_D     0b00001000
#define VFD_SEG_E     0b00010000
#define VFD_SEG_F     0b00100000
#define VFD_SEG_G     0b01000000
#define VFD_SEG_H     0b10000000

#define VFD_DIGIT_0   0b000000001
#define VFD_DIGIT_1   0b000000010
#define VFD_DIGIT_2   0b000000100
#define VFD_DIGIT_3   0b000001000
#define VFD_DIGIT_4   0b000010000
#define VFD_DIGIT_5   0b000100000
#define VFD_DIGIT_6   0b001000000
#define VFD_DIGIT_7   0b010000000
#define VFD_DIGIT_8   0b100000000

#define SEG_A 19
#define SEG_B 17
#define SEG_C 14
#define SEG_D 13
#define SEG_E 15
#define SEG_F 18
#define SEG_G 16
#define SEG_H 11

#define DIG_1 4
#define DIG_2 12
#define DIG_3 5
#define DIG_4 10
#define DIG_5 6
#define DIG_6 9
#define DIG_7 8
#define DIG_8 7
#define DIG_9 3

#define SPK1 1
#define SPK2 2
#define SPK_PORT PORTB
#define SPK_DDR DDRB

const uint8_t digittable[] PROGMEM = {
  DIG_9, DIG_8, DIG_7, DIG_6, DIG_5, DIG_4, DIG_3, DIG_2, DIG_1
};

const uint8_t segmenttable[] PROGMEM = {
  //SEG_H, SEG_G,  SEG_F,  SEG_E,  SEG_D,  SEG_C,  SEG_B,  SEG_A 
  SEG_A, SEG_B,  SEG_C,  SEG_D,  SEG_E,  SEG_F,  SEG_G,  SEG_H 
};


#define MENU_TIMEOUT  10000
static const unsigned int vfd_font[] = {
  /* 0 - 9 */
  VFD_SEG_A | VFD_SEG_B | VFD_SEG_C | VFD_SEG_D | VFD_SEG_E | VFD_SEG_F,
  VFD_SEG_B | VFD_SEG_C,
  VFD_SEG_A | VFD_SEG_B | VFD_SEG_D | VFD_SEG_E | VFD_SEG_G,
  VFD_SEG_A | VFD_SEG_B | VFD_SEG_C | VFD_SEG_D | VFD_SEG_G,
  VFD_SEG_B | VFD_SEG_C | VFD_SEG_F | VFD_SEG_G,
  VFD_SEG_A | VFD_SEG_C | VFD_SEG_D | VFD_SEG_F | VFD_SEG_G,
  VFD_SEG_A | VFD_SEG_C | VFD_SEG_D | VFD_SEG_E | VFD_SEG_F | VFD_SEG_G,
  VFD_SEG_A | VFD_SEG_B | VFD_SEG_C,
  VFD_SEG_A | VFD_SEG_B | VFD_SEG_C | VFD_SEG_D | VFD_SEG_E | VFD_SEG_F | VFD_SEG_G,
  VFD_SEG_A | VFD_SEG_B | VFD_SEG_C | VFD_SEG_F | VFD_SEG_G,
  
  /* a - z */
  VFD_SEG_A | VFD_SEG_B | VFD_SEG_C | VFD_SEG_D | VFD_SEG_E | VFD_SEG_G,
  VFD_SEG_C | VFD_SEG_D | VFD_SEG_E | VFD_SEG_F | VFD_SEG_G,
  VFD_SEG_D | VFD_SEG_E | VFD_SEG_G,
  VFD_SEG_B | VFD_SEG_C | VFD_SEG_D | VFD_SEG_E | VFD_SEG_G,
  VFD_SEG_A | VFD_SEG_B | VFD_SEG_D | VFD_SEG_E | VFD_SEG_F | VFD_SEG_G,
  VFD_SEG_A | VFD_SEG_E | VFD_SEG_F | VFD_SEG_G,
  VFD_SEG_A | VFD_SEG_B | VFD_SEG_C | VFD_SEG_D | VFD_SEG_F | VFD_SEG_G,
  VFD_SEG_C | VFD_SEG_E | VFD_SEG_F | VFD_SEG_G,
  VFD_SEG_B | VFD_SEG_C,
  VFD_SEG_B | VFD_SEG_C | VFD_SEG_D | VFD_SEG_E,
  VFD_SEG_A | VFD_SEG_C | VFD_SEG_E | VFD_SEG_F | VFD_SEG_G,
  VFD_SEG_D | VFD_SEG_E | VFD_SEG_F,
  VFD_SEG_A | VFD_SEG_C | VFD_SEG_E | VFD_SEG_G,
  VFD_SEG_C | VFD_SEG_E | VFD_SEG_G,
  VFD_SEG_C | VFD_SEG_D | VFD_SEG_E | VFD_SEG_G,
  VFD_SEG_A | VFD_SEG_B | VFD_SEG_E | VFD_SEG_F | VFD_SEG_G,
  VFD_SEG_A | VFD_SEG_B | VFD_SEG_C | VFD_SEG_D | VFD_SEG_G | VFD_SEG_H,
  VFD_SEG_E | VFD_SEG_G,
  VFD_SEG_A | VFD_SEG_C | VFD_SEG_D | VFD_SEG_F | VFD_SEG_G,
  VFD_SEG_D | VFD_SEG_E | VFD_SEG_F | VFD_SEG_G,
  VFD_SEG_C | VFD_SEG_D | VFD_SEG_E,
  VFD_SEG_C | VFD_SEG_D | VFD_SEG_E,
  VFD_SEG_A | VFD_SEG_C | VFD_SEG_D | VFD_SEG_E,
  VFD_SEG_B | VFD_SEG_C | VFD_SEG_E | VFD_SEG_F | VFD_SEG_G,
  VFD_SEG_B | VFD_SEG_C | VFD_SEG_D | VFD_SEG_F | VFD_SEG_G,
  VFD_SEG_A | VFD_SEG_B | VFD_SEG_D | VFD_SEG_E | VFD_SEG_G,

};

static const char *month_abbrevs[] = {
  "Jan",
  "Feb",
  "Mar",
  "Apr",
  "May",
  "Jun",
  "Jul",
  "Aug",
  "Sep",
  "Oct",
  "Nov",
  "Dec",
};

